searchNodes=[{"doc":"Gringotts is a payment gateway integration library for merchants Gringotts provides a unified interface for multiple Payment Gateways to make it easy for merchants to use multiple gateways. All gateways must conform to the API as described in this module, but can also support more gateway features than those required by Gringotts. Standard API arguments gateway (Module) Name The gateway to which this request is made. This is required in all API calls because Gringotts supports multiple Gateways. Example If you've configured Gringotts to work with Stripe, you'll do this to make an authorization request: Gringotts . authorize ( Gingotts.Gateways.Stripe , other args ... ) amount and currency This argument represents the &quot;amount&quot;, annotated with the currency unit for the transaction. amount is polymorphic thanks to the Gringotts.Money protocol which can even be implemented by your very own custom Money type! Currently, we support only ex_money 's Money type. Please don't forget to add the ex_money lib to your deps! Note Gringotts supports ex_money out of the box, just drop ex_money types in this argument and everything will work as expected. Support for monetized and money would be nice, but is currently not planned. When this highly precise amount is serialized into the network request, we use a potentially lossy Gringotts.Money.to_string/1 or Gringotts.Money.to_integer/1 to perform rounding (if required) using the half-even strategy. Hence, to protect your interests, and save real money, we STRONGLY RECOMMEND that (you) merchants perform any required rounding and handle remainders in their application logic -- before passing the amount to Gringotts's API. Example If you use ex_money in your project, and want to make an authorization for $2.99 to the XYZ Gateway, you'll do the following: # the money lib is aliased as &quot;MoneyLib&quot; amount = MoneyLib . new ( &quot;2.99&quot; , :USD ) Gringotts . authorize ( Gringotts.Gateways.XYZ , amount , some_card , extra_options ) card , a payment source Gringotts provides a Gringotts.CreditCard type to hold card parameters which merchants fetch from their clients. You (the merchant) needs to be PCI-DSS compliant to be able to use this. The same type can also hold Debit card details. Some gateways do not provide direct API integrations even for PCI compliant merchants, and force every merchant to use their client-side integration to generate a card token. Thus for such gateways, Gringotts accepts a string card-token instead of (or in addition to) a CreditCard.t struct. Please refer the &quot;Notes&quot; section of your chosen gateway to find what the card argument accepts. Note Gringotts only supports payment by debit or credit card, even though the gateways might support payment via other instruments such as e-wallets, vouchers, bitcoins or banks. Support for these instruments is planned in future releases. % CreditCard { first_name : &quot;Harry&quot; , last_name : &quot;Potter&quot; , number : &quot;4242424242424242&quot; , month : 12 , year : 2099 , verification_code : &quot;123&quot; , brand : &quot;VISA&quot; } opts for optional params opts is a keyword list of other options/information accepted by the gateway. The format, use and structure is gateway specific and documented in the Gateway's docs. Configuration Merchants must provide Gateway specific configuration in their application config in the usual elixir style. The required and optional fields are documented in every Gateway. The required config keys are validated at runtime, as they include authentication information. See Gringotts.Adapter.validate_config/2 . Global config This is set using the :global_config key once in your application. :mode Gateways usually provide sandboxed environments to test applications and the merchant can use the :mode switch to choose between the sandbox or live environment. Available Options: :test -- for sandbox environment, all requests will be routed to the gateway's sandbox/test API endpoints. Use this in your :dev and :test environments. :prod -- for live environment, all requests will reach the financial and banking networks. Switch to this in your application's :prod environment. Example config :gringotts , :global_config , # for live environment mode : :prod Gateway specific config The gateway level config is documented in their docs. They must be of the following format: config :gringotts , Gringotts.Gateways.XYZ , # some_documented_key: associated_value # some_other_key: another_value","ref":"Gringotts.html","title":"Gringotts","type":"module"},{"doc":"Performs a (pre) Authorize operation. The authorization validates the card details with the banking network, places a hold on the transaction amount in the customer’s issuing bank and may also trigger risk management. Funds are not transferred, until the authorization is capture/3 d. capture/3 must also be implemented alongwith this. Example To (pre) authorize a payment of $4.20 on a sample card with the XYZ gateway, amount = Money . new ( &quot;4.2&quot; , :USD ) card = % Gringotts.CreditCard { first_name : &quot;Harry&quot; , last_name : &quot;Potter&quot; , number : &quot;4200000000000000&quot; , year : 2099 , month : 12 , verification_code : &quot;123&quot; , brand : &quot;VISA&quot; } { :ok , auth_result } = Gringotts . authorize ( Gringotts.Gateways.XYZ , amount , card , opts )","ref":"Gringotts.html#authorize/4","title":"Gringotts.authorize/4","type":"function"},{"doc":"Captures a pre-authorized amount . amount is transferred to the merchant account. The gateway might support, partial captures, multiple captures, per authorization Example To capture $4.20 on a previously authorized payment worth $4.20 by referencing the obtained authorization id with the XYZ gateway, auth_result # The result of an `authorize/3` request. amount = Money . new ( &quot;4.2&quot; , :USD ) Gringotts . capture ( Gringotts.Gateways.XYZ , amount , auth_result . id , opts )","ref":"Gringotts.html#capture/4","title":"Gringotts.capture/4","type":"function"},{"doc":"Transfers amount from the customer to the merchant. Gateway attempts to process a purchase on behalf of the customer, by debiting amount from the customer's account by charging the customer's card . This method can be implemented as a chained call to authorize/3 and capture/3 . But it must be implemented as a single call to the Gateway if it provides a specific endpoint or action for this. *Note! All gateways must implement (atleast) this method. Example To process a purchase worth $4.2, with the XYZ gateway, amount = Money . new ( &quot;4.2&quot; , :USD ) card = % Gringotts.CreditCard { first_name : &quot;Harry&quot; , last_name : &quot;Potter&quot; , number : &quot;4200000000000000&quot; , year : 2099 , month : 12 , verification_code : &quot;123&quot; , brand : &quot;VISA&quot; } Gringotts . purchase ( Gringotts.Gateways.XYZ , amount , card , opts )","ref":"Gringotts.html#purchase/4","title":"Gringotts.purchase/4","type":"function"},{"doc":"Refunds the amount to the customer's account with reference to a prior transfer. The end customer will usually see two bookings/records on his statement. Example To refund a previous purchase worth $4.20 referenced by id , with the XYZ gateway, amount = Money . new ( &quot;4.2&quot; , :USD ) Gringotts . purchase ( Gringotts.Gateways.XYZ , amount , id , opts )","ref":"Gringotts.html#refund/4","title":"Gringotts.refund/4","type":"function"},{"doc":"Stores the payment-source data for later use, returns a token . The token must be returned in the Response.token field. Note This usually enables One-Click and Recurring payments. Example To store a card (a payment-source) for future use, with the XYZ gateway, card = % Gringotts.CreditCard { first_name : &quot;Harry&quot; , last_name : &quot;Potter&quot; , number : &quot;4200000000000000&quot; , year : 2099 , month : 12 , verification_code : &quot;123&quot; , brand : &quot;VISA&quot; } Gringotts . store ( Gringotts.Gateways.XYZ , card , opts )","ref":"Gringotts.html#store/3","title":"Gringotts.store/3","type":"function"},{"doc":"Removes a previously token from the gateway Once unstore/3 d, the token must becom invalid, though some gateways might not support this feature. Example To unstore with the XYZ gateway, token = &quot;some_privileged_customer&quot; Gringotts . unstore ( Gringotts.Gateways.XYZ , token )","ref":"Gringotts.html#unstore/3","title":"Gringotts.unstore/3","type":"function"},{"doc":"Voids the referenced payment. This method attempts a reversal/immediate cancellation of the a previous transaction referenced by id . As a consequence, the customer usually won't see any booking on his statement. Example To void a previous (pre) authorization with the XYZ gateway, id = &quot;some_previously_obtained_token&quot; Gringotts . void ( Gringotts.Gateways.XYZ , id , opts )","ref":"Gringotts.html#void/3","title":"Gringotts.void/3","type":"function"},{"doc":"Validates the &quot;required&quot; configuration. All gateway modules must use this module, which provides a run-time configuration validator. Gringotts picks up the merchant's Gateway authentication secrets from the Application config. The configuration validator can be customized by providing a list of required_config keys. The validator will check if these keys are available at run-time, before each call to the Gateway. Example Say a merchant must provide his secret_user_name and secret_password to some Gateway XYZ . Then, Gringotts expects that the GatewayXYZ module would use Adapter in the following manner: defmodule Gringotts.Gateways.GatewayXYZ do use Gringotts.Adapter , required_config : [ :secret_user_name , :secret_password ] use Gringotts.Gateways.Base # the rest of the implentation end And, the merchant woud provide these secrets in the Application config, possibly via config/config.exs like so, # config/config.exs config :gringotts , Gringotts.Gateways.GatewayXYZ , adapter : Gringotts.Gateways.GatewayXYZ , secret_user_name : &quot;some_really_secret_user_name&quot; , secret_password : &quot;some_really_secret_password&quot;","ref":"Gringotts.Adapter.html","title":"Gringotts.Adapter","type":"module"},{"doc":"Defines a struct for (credit) cards and some utilities.","ref":"Gringotts.CreditCard.html","title":"Gringotts.CreditCard","type":"module"},{"doc":"Returns the full name of the card holder. Joins first_name and last_name with a space in between.","ref":"Gringotts.CreditCard.html#full_name/1","title":"Gringotts.CreditCard.full_name/1","type":"function"},{"doc":"Represents a Credit Card. Field Type Description number string The card number. month integer Month of expiry (a number in the 1..12 range). year integer Year of expiry. first_name string First name of the card holder (as on card). last_name string Last name of the card holder (as on card). verification_code string The Card Verification Code , usually a 3-4 digit number on the back of the card. brand string The brand name of the card network (in some cases also the card issuer) in UPPERCASE. Some popular card networks are Visa , MasterCard , Maestro , Diner's Club etc.","ref":"Gringotts.CreditCard.html#t:t/0","title":"Gringotts.CreditCard.t/0","type":"type"},{"doc":"Money protocol used by the Gringotts API. The amount argument required for some of Gringotts' API methods must implement this protocol. If your application is already using a supported Money library, just pass in the Money struct and things will work out of the box. Otherwise, just wrap your amount with the currency together in a Map like so, price = %{ value : Decimal . new ( &quot;20.18&quot; ) , currency : &quot;USD&quot; } and the API will accept it (as long as the currency is valid ISO 4217 currency code ). Note on the Any implementation Both to_string/1 and to_integer/1 assume that the precision for the currency is 2 digits after decimal.","ref":"Gringotts.Money.html","title":"Gringotts.Money","type":"protocol"},{"doc":"Returns the ISO 4217 compliant currency code associated with this sum of money. This must be an UPCASE string","ref":"Gringotts.Money.html#currency/1","title":"Gringotts.Money.currency/1","type":"function"},{"doc":"Returns the ISO4217 currency code as string and value as an integer. Useful for gateways that require amount as integer (like cents instead of dollars). Note Conversion from Decimal.t to integer is potentially lossy and the rounding (if required) is performed (automatically) by the Money library defining the type, or in the implementation of this protocol method. If you want to implement this method for your custom type, please ensure that the rounding strategy (if any rounding is applied) must be half_even . To keep things predictable and transparent, merchants should round the amount themselves , perhaps by explicitly calling the relevant method of the Money library in their application before passing it to Gringotts 's public API. Examples # the money lib is aliased as &quot;MoneyLib&quot; iex&gt; usd_price = MoneyLib . new ( &quot;4.1234&quot; , :USD ) # MoneyLib &lt; 4.1234 , &quot;USD&quot; &gt; iex&gt; Gringotts.Money . to_integer ( usd_price ) { &quot;USD&quot; , 412 , - 2 } iex&gt; bhd_price = MoneyLib . new ( &quot;4.1234&quot; , :BHD ) # MoneyLib &lt; 4.1234 , &quot;BHD&quot; &gt; iex&gt; Gringotts.Money . to_integer ( bhd_price ) { &quot;BHD&quot; , 4123 , - 3 } # the Bahraini dinar is divided into 1000 fils unlike the dollar which is # divided in 100 cents","ref":"Gringotts.Money.html#to_integer/1","title":"Gringotts.Money.to_integer/1","type":"function"},{"doc":"Returns a tuple of ISO4217 currency code and the value as strings. The stringified value must match this regex: ~r/-?\\d+\\.\\d\\d{n}/ where n+1 should match the required precision for the currency . There should be no place value separators except the decimal point (like commas). Gringotts will not (and cannot) validate this of course. Note Conversion from Decimal.t to string is potentially lossy and the rounding (if required) is performed (automatically) by the Money library defining the type, or in the implementation of this protocol method. If you want to implement this method for your custom type, please ensure that the rounding strategy (if any rounding is applied) must be half_even . To keep things predictable and transparent, merchants should round the amount themselves , perhaps by explicitly calling the relevant method of the Money library in their application before passing it to Gringotts 's public API. Examples # the money lib is aliased as &quot;MoneyLib&quot; iex&gt; usd_price = MoneyLib . new ( &quot;4.1234&quot; , :USD ) # MoneyLib &lt; 4.1234 , &quot;USD&quot; &gt; iex&gt; Gringotts.Money . to_string ( usd_price ) { &quot;USD&quot; , &quot;4.12&quot; } iex&gt; bhd_price = MoneyLib . new ( &quot;4.1234&quot; , :BHD ) # MoneyLib &lt; 4.1234 , &quot;BHD&quot; &gt; iex&gt; Gringotts.Money . to_string ( bhd_price ) { &quot;BHD&quot; , &quot;4.123&quot; }","ref":"Gringotts.Money.html#to_string/1","title":"Gringotts.Money.to_string/1","type":"function"},{"doc":"Returns a Decimal.t representing the &quot;worth&quot; of this sum of money in the associated currency .","ref":"Gringotts.Money.html#value/1","title":"Gringotts.Money.value/1","type":"function"},{"doc":"","ref":"Gringotts.Money.html#t:t/0","title":"Gringotts.Money.t/0","type":"type"},{"doc":"Defines the Response struct and some utilities. All Gringotts public API calls will return a Response.t wrapped in an :ok or :error tuple . It is guaranteed that an :ok will be returned only when the request succeeds at the gateway, ie, no error occurs.","ref":"Gringotts.Response.html","title":"Gringotts.Response","type":"module"},{"doc":"","ref":"Gringotts.Response.html#error/1","title":"Gringotts.Response.error/1","type":"function"},{"doc":"","ref":"Gringotts.Response.html#success/1","title":"Gringotts.Response.success/1","type":"function"},{"doc":"The standard Response from Gringotts . Field Type Description success boolean Indicates the status of the transaction. id String.t Gateway supplied identifier of the transaction. token String.t Gateway supplied token . This is different from Response.id . status_code non_neg_integer HTTP response code. gateway_code String.t Gateway's response code &quot;as-is&quot;. message String.t String describing the response status. avs_result map Address Verification Result. Schema: %{street: String.t, zip_code: String.t} cvc_result String.t Result of the CVC validation. reason String.t Explain the reason of error, in case of error. nil otherwise. raw String.t Raw response from the gateway. fraud_review term Gateway's risk assessment of the transaction. Notes It is not guaranteed that all fields will be populated for all calls, and some gateways might insert non-standard fields. Please refer the Gateways' docs for that information. success is deprecated in v1.1.0 and will be removed in v1.2.0 . For some actions the Gateway returns an additional token, say as reponse to a customer tokenization/registration. In such cases the id is not useable because it refers to the transaction, the token is. On the other hand for authorizations or captures, there's no token . The schema of fraud_review is Gateway specific.","ref":"Gringotts.Response.html#t:t/0","title":"Gringotts.Response.t/0","type":"type"},{"doc":"Generates a barebones implementation for a gateway. It expects the (brand) name of the gateway as argument and we recommend that it be capitalized. This will not necessarily be the module name . mix gringotts . new NAME [ - m , -- module MODULE ] [ - f , -- file FILENAME ] [ -- url URL ] A barebones implementation of the gateway will be created along with skeleton mock and integration tests in lib/gringotts/gateways/ . The command will prompt for the module name, and other metadata. Options Tip! You can supply the extra arguments to gringotts.new to skip (some of) the prompts. -m --module - The module name for the Gateway. -f --file - The filename. --url - The homepage of the gateway. Examples mix gringotts . new FooBar The prompts for this will be: MODULE = &quot;Foobar&quot; URL = &quot;https://www.foobar.com&quot; FILENAME = &quot;foo_bar.ex&quot;","ref":"Mix.Tasks.Gringotts.New.html","title":"Mix.Tasks.Gringotts.New","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.Gringotts.New.html#run/1","title":"Mix.Tasks.Gringotts.New.run/1","type":"function"},{"doc":"A module for working with the Authorize.Net payment gateway. Refer the official Authorize.Net API docs . The following set of functions for Authorize.Net have been implemented: Action Method Authorize a Credit Card authorize/3 Capture a previously authorized amount capture/3 Charge a Credit Card purchase/3 Refund a transaction refund/3 Void a transaction void/2 Create Customer Profile store/2 Create Customer Payment Profile store/2 Delete Customer Profile unstore/2 Most Gringotts API calls accept an optional Keyword list opts to supply optional arguments for transactions with the Authorize.Net gateway. The following keys are supported: Key customer invoice bill_to ship_to customer_ip order lineitems ref_id tax duty shipping po_number customer_type customer_profile_id profile To know more about these keywords check the Request and Response tabs for each API method. Notes Though Authorize.Net supports multiple currencies however, multiple currencies in one account is not supported. A merchant would need multiple Authorize.Net accounts, one for each chosen currency. Please refer the section on &quot;Supported acquirers and currencies&quot; here . You, the merchant needs to be PCI-DSS Compliant if you wish to use this module. Your server will recieve sensitive card and customer information. The responses of this module include a non-standard field: :cavv_result . :cavv_result is the &quot;cardholder authentication verification response code&quot;. In case of Mastercard transactions, this field will always be nil . Please refer the &quot;Response Format&quot; section in the docs for more details. Configuring your AuthorizeNet account at Gringotts To use this module you need to create an account with the Authorize.Net gateway and obtain your login secrets: name and transactionKey . Your Application config must include the name and transaction_key fields and would look something like this: config :gringotts , Gringotts.Gateways.AuthorizeNet , name : &quot;name_provided_by_authorize_net&quot; , transaction_key : &quot;transactionKey_provided_by_authorize_net&quot; Scope of this module Although Authorize.Net supports payments from various sources (check your dashboard ), this library currently accepts payments by (supported) credit cards only. Following the examples First, set up a sample application and configure it to work with Authorize.Net. You could do that from scratch by following our Getting Started guide. To save you time, we recommend cloning our example repo that gives you a pre-configured sample app ready-to-go. You could use the same config or update it the with your &quot;secrets&quot; above . To save a lot of time, create a .iex.exs file as shown in this gist to introduce a set of handy bindings and aliases. We'll be using these bindings in the examples below.","ref":"Gringotts.Gateways.AuthorizeNet.html","title":"Gringotts.Gateways.AuthorizeNet","type":"module"},{"doc":"Authorize a credit card transaction. The authorization validates the card details with the banking network, places a hold on the transaction amount in the customer’s issuing bank and also triggers risk management. Funds are not transferred. To transfer the funds to merchant's account follow this up with a capture/3 . Authorize.Net returns a transId (available in the Response.id field) which can be used for: capture/3 an authorized transaction. void/2 a transaction. Optional Fields opts = [ order : %{ invoice_number : String , description : String } , ref_id : String , lineitems : %{ item_id : String , name : String , description : String , quantity : Integer , unit_price : Gringotts.Money . t ( ) } , tax : %{ amount : Gringotts.Money . t ( ) , name : String , description : String } , duty : %{ amount : Gringotts.Money . t ( ) , name : String , description : String } , shipping : %{ amount : Gringotts.Money . t ( ) , name : String , description : String } , po_number : String , customer : %{ id : String } , bill_to : %{ first_name : String , last_name : String , company : String , address : String , city : String , state : String , zip : String , country : String } , ship_to : %{ first_name : String , last_name : String , company : String , address : String , city : String , state : String , zip : String , country : String } , customer_ip : String ] Example iex&gt; amount = Money . new ( 20 , :USD ) iex&gt; opts = [ ref_id : &quot;123456&quot; , order : %{ invoice_number : &quot;INV-12345&quot; , description : &quot;Product Description&quot; } , lineitems : %{ item_id : &quot;1&quot; , name : &quot;vase&quot; , description : &quot;Cannes logo&quot; , quantity : 1 , unit_price : amount } , tax : %{ name : &quot;VAT&quot; , amount : Money . new ( &quot;0.1&quot; , :EUR ) , description : &quot;Value Added Tax&quot; } , shipping : %{ name : &quot;SAME-DAY-DELIVERY&quot; , amount : Money . new ( &quot;0.56&quot; , :EUR ) , description : &quot;Zen Logistics&quot; } , duty : %{ name : &quot;import_duty&quot; , amount : Money . new ( &quot;0.25&quot; , :EUR ) , description : &quot;Upon import of goods&quot; } ] iex&gt; card = % CreditCard { number : &quot;5424000000000015&quot; , year : 2099 , month : 12 , verification_code : &quot;999&quot; } iex&gt; result = Gringotts . authorize ( Gringotts.Gateways.AuthorizeNet , amount , card , opts )","ref":"Gringotts.Gateways.AuthorizeNet.html#authorize/3","title":"Gringotts.Gateways.AuthorizeNet.authorize/3","type":"function"},{"doc":"Captures a pre-authorized amount . amount is transferred to the merchant account by Authorize.Net when it is smaller or equal to the amount used in the pre-authorization referenced by id . Authorize.Net returns a transId (available in the Response.id field) which can be used to: refund/3 a settled transaction. void/2 a transaction. Notes Authorize.Net automatically settles authorized transactions after 24 hours. Hence, unnecessary authorizations must be void/2 ed within this period! Though Authorize.Net supports partial capture of the authorized amount , it is advised not to do so. Optional Fields opts = [ order : %{ invoice_number : String , description : String } , ref_id : String ] Example iex&gt; opts = [ ref_id : &quot;123456&quot; ] iex&gt; amount = Money . new ( 20 , :USD ) iex&gt; id = &quot;123456&quot; iex&gt; result = Gringotts . capture ( Gringotts.Gateways.AuthorizeNet , id , amount , opts )","ref":"Gringotts.Gateways.AuthorizeNet.html#capture/3","title":"Gringotts.Gateways.AuthorizeNet.capture/3","type":"function"},{"doc":"Transfers amount from the customer to the merchant. Charges a credit card for the specified amount . It performs authorize and capture at the same time . Authorize.Net returns transId (available in the Response.id field) which can be used to: refund/3 a settled transaction. void/2 a transaction. Optional Fields opts = [ order : %{ invoice_number : String , description : String } , ref_id : String , lineitems : %{ item_id : String , name : String , description : String , quantity : Integer , unit_price : Gringotts.Money . t ( ) } , tax : %{ amount : Gringotts.Money . t ( ) , name : String , description : String } , duty : %{ amount : Gringotts.Money . t ( ) , name : String , description : String } , shipping : %{ amount : Gringotts.Money . t ( ) , name : String , description : String } , po_number : String , customer : %{ id : String } , bill_to : %{ first_name : String , last_name : String , company : String , address : String , city : String , state : String , zip : String , country : String } , ship_to : %{ first_name : String , last_name : String , company : String , address : String , city : String , state : String , zip : String , country : String } , customer_ip : String ] Example iex&gt; amount = Money . new ( 20 , :USD ) iex&gt; opts = [ ref_id : &quot;123456&quot; , order : %{ invoice_number : &quot;INV-12345&quot; , description : &quot;Product Description&quot; } , lineitems : %{ item_id : &quot;1&quot; , name : &quot;vase&quot; , description : &quot;Cannes logo&quot; , quantity : 1 , unit_price : amount } , tax : %{ name : &quot;VAT&quot; , amount : Money . new ( &quot;0.1&quot; , :EUR ) , description : &quot;Value Added Tax&quot; } , shipping : %{ name : &quot;SAME-DAY-DELIVERY&quot; , amount : Money . new ( &quot;0.56&quot; , :EUR ) , description : &quot;Zen Logistics&quot; } , duty : %{ name : &quot;import_duty&quot; , amount : Money . new ( &quot;0.25&quot; , :EUR ) , description : &quot;Upon import of goods&quot; } ] iex&gt; card = % CreditCard { number : &quot;5424000000000015&quot; , year : 2099 , month : 12 , verification_code : &quot;999&quot; } iex&gt; result = Gringotts . purchase ( Gringotts.Gateways.AuthorizeNet , amount , card , opts )","ref":"Gringotts.Gateways.AuthorizeNet.html#purchase/3","title":"Gringotts.Gateways.AuthorizeNet.purchase/3","type":"function"},{"doc":"Refund amount for a settled transaction referenced by id . The payment field in the opts is used to set the instrument/mode of payment, which could be different from the original one. Currently, we support only refunds to cards, so put the card details in the payment . Required fields opts = [ payment : %{ card : %{ number : String , year : Integer , month : Integer } } ] Optional fields opts = [ ref_id : String ] Example iex&gt; opts = [ payment : %{ card : %{ number : &quot;5424000000000015&quot; , year : 2099 , month : 12 } } ref_id : &quot;123456&quot; ] iex&gt; id = &quot;123456&quot; iex&gt; amount = Money . new ( 20 , :USD ) iex&gt; result = Gringotts . refund ( Gringotts.Gateways.AuthorizeNet , amount , id , opts )","ref":"Gringotts.Gateways.AuthorizeNet.html#refund/3","title":"Gringotts.Gateways.AuthorizeNet.refund/3","type":"function"},{"doc":"Store a customer's profile and optionally associate it with a payment profile. Authorize.Net separates a customer's profile from their payment profile. Thus a customer can have multiple payment profiles. Create both profiles Add :customer details in opts and also provide card details. The response will contain a :customer_profile_id . Associate payment profile with existing customer profile Simply pass the :customer_profile_id in the opts . This will add the card details to the profile referenced by the supplied :customer_profile_id . Notes Currently only supports credit card in the payment profile. The supplied card details can be validated by supplying a :validation_mode , available options are testMode and liveMode , the deafult is testMode . Required Fields opts = [ profile : %{ merchant_customer_id : String , description : String , email : String } ] Optional Fields opts = [ validation_mode : String , bill_to : %{ first_name : String , last_name : String , company : String , address : String , city : String , state : String , zip : String , country : String } , customer_type : String , customer_profile_id : String ] Example iex&gt; opts = [ profile : %{ merchant_customer_id : 123456 , description : &quot;test store&quot; , email : &quot;test@gmail.com&quot; } , validation_mode : &quot;testMode&quot; ] iex&gt; card = % CreditCard { number : &quot;5424000000000015&quot; , year : 2099 , month : 12 , verification_code : &quot;999&quot; } iex&gt; result = Gringotts . store ( Gringotts.Gateways.AuthorizeNet , card , opts )","ref":"Gringotts.Gateways.AuthorizeNet.html#store/2","title":"Gringotts.Gateways.AuthorizeNet.store/2","type":"function"},{"doc":"Remove a customer profile from the payment gateway. Use this function to unstore the customer card information by deleting the customer profile present. Requires the customer profile id. Example iex&gt; id = &quot;123456&quot; iex&gt; result = Gringotts . store ( Gringotts.Gateways.AuthorizeNet , id )","ref":"Gringotts.Gateways.AuthorizeNet.html#unstore/2","title":"Gringotts.Gateways.AuthorizeNet.unstore/2","type":"function"},{"doc":"Catches gateway configuration errors. Raises a run-time ArgumentError if any of the required_config values is not available or missing from the Application config.","ref":"Gringotts.Gateways.AuthorizeNet.html#validate_config/1","title":"Gringotts.Gateways.AuthorizeNet.validate_config/1","type":"function"},{"doc":"Voids the referenced payment. This method attempts a reversal of the either a previous purchase/3 or authorize/3 referenced by id . It can cancel either an original transaction that may not be settled or an entire order composed of more than one transaction. Optional fields opts = [ ref_id : String ] Example iex&gt; opts = [ ref_id : &quot;123456&quot; ] iex&gt; id = &quot;123456&quot; iex&gt; result = Gringotts . void ( Gringotts.Gateways.AuthorizeNet , id , opts )","ref":"Gringotts.Gateways.AuthorizeNet.html#void/2","title":"Gringotts.Gateways.AuthorizeNet.void/2","type":"function"},{"doc":"Dummy implementation of the Gringotts API All gateway implementations must use this module as it provides (pseudo) implementations for the all methods of the Gringotts API. In case GatewayXYZ does not implement unstore , the following call would not raise an error: Gringotts . unstore ( GatewayXYZ , &quot;some_registration_id&quot; ) because this module provides an implementation.","ref":"Gringotts.Gateways.Base.html","title":"Gringotts.Gateways.Base","type":"module"},{"doc":"CAMS gateway implementation. CAMS provides a sandbox account with documentation under the integration tab . The login credentials are: Key Credentials username testintegrationc password password9 The video tutorials (on vimeo) are excellent. The following features of CAMS are implemented: Action Method Authorize authorize/3 Capture capture/3 Purchase purchase/3 Refund refund/3 Cancel void/2 The opts argument Most Gringotts API calls accept an optional keyword list opts to supply optional arguments for transactions with the CAMS gateway. The following keys are supported: Key Type Remark billing_address map The address of the customer order_id String.t Merchant provided identifier description String.t Merchant provided description of the transaction CAMS supports more optional keys and you can raise an issue if this is important to you. Schema billing_address is a map from atoms to String.t , and can include any of the keys from: :name, :address1, :address2, :company, :city, :state, :zip, :country, :phone, :fax] Registering your CAMS account at Gringotts Config parameter CAMS secret :username Username :password Password Your Application config must include the :username , :password fields and would look something like this: config :gringotts , Gringotts.Gateways.Cams , username : &quot;your_secret_user_name&quot; , password : &quot;your_secret_password&quot; , Scope of this module CAMS does not process money in cents. Although CAMS supports payments from electronic check &amp; various cards this module only accepts payments via VISA , MASTER , AMERICAN EXPRESS and DISCOVER . Supported countries citation-needed Supported currencies citation-needed Following the examples First, set up a sample application and configure it to work with CAMS. You could do that from scratch by following our Getting Started guide. To save you time, we recommend cloning our example that gives you a pre-configured sample app ready-to-go. You could use the same config or update it the with your &quot;secrets&quot; that you get after registering with CAMS . To save a lot of time, create a .iex.exs file as shown in this gist to introduce a set of handy bindings and aliases. We'll be using these bindings in the examples below. Integrating with phoenix Refer the GringottsPay website for an example of how to integrate CAMS with phoenix. The source is available here . TODO Operations using Credit Card Credit Operations using electronic checks Sale Void Refund","ref":"Gringotts.Gateways.Cams.html","title":"Gringotts.Gateways.Cams","type":"module"},{"doc":"Performs a (pre) Authorize operation. The authorization validates the card details with the banking network, places a hold on the transaction amount in the customer’s issuing bank and also triggers risk management. Funds are not transferred. When followed up with a capture/3 transaction, funds will be transferred to the merchant's account upon settlement. CAMS returns a Transaction ID (available in the Response.authorization field) which can be used later to: capture/3 an amount. void/2 an authorized transaction. Optional Fields options [ order_id : String , description : String ] Examples The following example shows how one would (pre) authorize a payment of $20 on a sample card . iex&gt; card = % CreditCard { first_name : &quot;Harry&quot; , last_name : &quot;Potter&quot; , number : &quot;4111111111111111&quot; , year : 2099 , month : 12 , verification_code : &quot;999&quot; , brand : &quot;VISA&quot; } iex&gt; money = Money . new ( 20 , :USD ) iex&gt; { :ok , auth_result } = Gringotts . authorize ( Gringotts.Gateways.Cams , money , card )","ref":"Gringotts.Gateways.Cams.html#authorize/3","title":"Gringotts.Gateways.Cams.authorize/3","type":"function"},{"doc":"Captures a pre-authorized amount. Captures can be submitted for an amount equal to or less than the originally authorized amount in an authorize/3 ation referenced by transaction_id . Partial captures are allowed, and the remaining amount is released back to the payment source (video) . Multiple, partial captures on the same authorization token are not supported . CAMS returns a Transaction ID (available in the Response.authorization field) which can be used later to: refund/3 void/2 (only before settlements!) Examples The following example shows how one would (partially) capture a previously authorized a payment worth $10 by referencing the obtained authorization id . iex&gt; card = % CreditCard { first_name : &quot;Harry&quot; , last_name : &quot;Potter&quot; , number : &quot;4111111111111111&quot; , year : 2099 , month : 12 , verification_code : &quot;999&quot; , brand : &quot;VISA&quot; } iex&gt; money = Money . new ( 10 , :USD ) iex&gt; authorization = auth_result . authorization # authorization = &quot;some_authorization_transaction_id&quot; iex&gt; { :ok , capture_result } = Gringotts . capture ( Gringotts.Gateways.Cams , money , authorization )","ref":"Gringotts.Gateways.Cams.html#capture/3","title":"Gringotts.Gateways.Cams.capture/3","type":"function"},{"doc":"Transfers amount from the customer to the merchant. CAMS attempts to process a purchase on behalf of the customer, by debiting amount from the customer's account by charging the customer's card . Returns a Transaction ID (available in the Response.authorization field) which can be used later to: refund/3 void/2 (only before settlements!) Examples The following example shows how one would process a payment worth $20 in one-shot, without (pre) authorization. iex&gt; card = % CreditCard { first_name : &quot;Harry&quot; , last_name : &quot;Potter&quot; , number : &quot;4111111111111111&quot; , year : 2099 , month : 12 , verification_code : &quot;999&quot; , brand : &quot;VISA&quot; } iex&gt; money = Money . new ( 20 , :USD ) iex&gt; Gringotts . purchase ( Gringotts.Gateways.Cams , money , card )","ref":"Gringotts.Gateways.Cams.html#purchase/3","title":"Gringotts.Gateways.Cams.purchase/3","type":"function"},{"doc":"Refunds the amount to the customer's account with reference to a prior transfer. It's better to void/2 a transaction if it has not been settled yet! Refunds lead to to two entries on the customer's bank statement, one for the original purchase/3 or capture/3 and another for the refund/3 . Multiple, partial refunds on the same Transaction ID are allowed till all the captured amount is refunded. Examples The following example shows how one would completely refund a previous capture (and similarily for purchases). iex&gt; capture_id = capture_result . authorization # capture_id = &quot;some_capture_transaction_id&quot; iex&gt; money = Money . new ( 20 , :USD ) iex&gt; Gringotts . refund ( Gringotts.Gateways.Cams , money , capture_id )","ref":"Gringotts.Gateways.Cams.html#refund/3","title":"Gringotts.Gateways.Cams.refund/3","type":"function"},{"doc":"Validates the card Verifies the credit card without authorizing any amount. Examples iex&gt; card = % CreditCard { first_name : &quot;Harry&quot; , last_name : &quot;Potter&quot; , number : &quot;4111111111111111&quot; , year : 2099 , month : 12 , verification_code : &quot;999&quot; , brand : &quot;VISA&quot; } iex&gt; Gringotts . validate ( Gringotts.Gateways.Cams , card )","ref":"Gringotts.Gateways.Cams.html#validate/2","title":"Gringotts.Gateways.Cams.validate/2","type":"function"},{"doc":"Catches gateway configuration errors. Raises a run-time ArgumentError if any of the required_config values is not available or missing from the Application config.","ref":"Gringotts.Gateways.Cams.html#validate_config/1","title":"Gringotts.Gateways.Cams.validate_config/1","type":"function"},{"doc":"Voids the referenced payment. Cancel a transaction referenced by transaction_id that is not settled yet. This will erase any entries from the customer's bank statement. authorize/3 can be void/2 ed to prevent captures. Examples The following example shows how one would void a previous (pre) authorization. iex&gt; auth_id = auth_result . id # auth_id = &quot;aome_authorisation_transaction_id&quot; iex&gt; Gringotts . void ( Gringotts.Gateways.Cams , auth_id )","ref":"Gringotts.Gateways.Cams.html#void/2","title":"Gringotts.Gateways.Cams.void/2","type":"function"},{"doc":"GlobalCollect gateway implementation. For further details, please refer GlobalCollect API documentation . Following are the features that have been implemented for GlobalCollect: Action Method Authorize authorize/3 Purchase purchase/3 Capture capture/3 Refund refund/3 Void void/2 Optional parameters Most Gringotts API calls accept an optional Keyword list opts to supply optional arguments for transactions with the gateway. Key Remark merchantCustomerId Identifier for the consumer that can be used as a search criteria in the Global Collect Payment Console description Descriptive text that is used towards to consumer, either during an online checkout at a third party and/or on the statement of the consumer dob The date of birth of the consumer Format: YYYYMMDD company Name of company, as a consumer email Email address of the consumer phone Phone number of the consumer invoice Object containing additional invoice data billingAddress Object containing billing address details shippingAddress Object containing shipping address details name Object containing the name details of the consumer skipAuthentication 3D Secure Authentication will be skipped for this transaction if set to true For more details of the required keys refer this. Registering your GlobalCollect account at Gringotts After creating your account successfully on GlobalCollect open the dashboard to fetch the secret_api_key , api_key_id and merchant_id from the menu. Here's how the secrets map to the required configuration parameters for GlobalCollect: Config parameter GlobalCollect secret :secret_api_key SecretApiKey :api_key_id ApiKeyId :merchant_id MerchantId Your Application config must include the :secret_api_key , :api_key_id , :merchant_id field(s) and would look something like this: config :gringotts , Gringotts.Gateways.GlobalCollect , secret_api_key : &quot;your_secret_secret_api_key&quot; api_key_id : &quot;your_secret_api_key_id&quot; merchant_id : &quot;your_secret_merchant_id&quot; ## Scope of this module All amount fields in globalCollect are in cents with each amount having 2 decimals. Supported currencies and countries The GlobalCollect platform supports payments in over 150 currencies . Following the examples First, set up a sample application and configure it to work with GlobalCollect. You could do that from scratch by following our Getting Started guide. To save you time, we recommend cloning our example repo that gives you a pre-configured sample app ready-to-go. You could use the same config or update it the with your &quot;secrets&quot; as described above . Run an iex session with iex -S mix and add some variable bindings and aliases to it (to save some time): iex&gt; alias Gringotts . { Response , CreditCard , Gateways.GlobalCollect } iex&gt; shippingAddress = %{ street : &quot;Desertroad&quot; , houseNumber : &quot;1&quot; , additionalInfo : &quot;Suite II&quot; , zip : &quot;84536&quot; , city : &quot;Monument Valley&quot; , state : &quot;Utah&quot; , countryCode : &quot;US&quot; } iex&gt; billingAddress = %{ street : &quot;Desertroad&quot; , houseNumber : &quot;13&quot; , additionalInfo : &quot;b&quot; , zip : &quot;84536&quot; , city : &quot;Monument Valley&quot; , state : &quot;Utah&quot; , countryCode : &quot;US&quot; } iex&gt; invoice = %{ invoiceNumber : &quot;000000123&quot; , invoiceDate : &quot;20140306191500&quot; } iex&gt; name = %{ title : &quot;Miss&quot; , firstName : &quot;Road&quot; , surname : &quot;Runner&quot; } iex&gt; card = % CreditCard { number : &quot;4567350000427977&quot; , month : 12 , year : 43 , first_name : &quot;John&quot; , last_name : &quot;Doe&quot; , verification_code : &quot;123&quot; , brand : &quot;VISA&quot; } iex&gt; opts = [ description : &quot;Store Purchase 1437598192&quot; , merchantCustomerId : &quot;234&quot; , dob : &quot;19490917&quot; , company : &quot;asma&quot; , email : &quot;johndoe@gmail.com&quot; , phone : &quot;7765746563&quot; , invoice : invoice , billingAddress : billingAddress , shippingAddress : shippingAddress , name : name , skipAuthentication : &quot;true&quot; ] We'll be using these in the examples below.","ref":"Gringotts.Gateways.GlobalCollect.html","title":"Gringotts.Gateways.GlobalCollect","type":"module"},{"doc":"Performs a (pre) Authorize operation. The authorization validates the card details with the banking network, places a hold on the transaction amount in the customer’s issuing bank and also triggers risk management. Funds are not transferred. GlobalCollect returns a payment id which can be further used to: capture/3 an amount. refund/3 an amount void/2 a pre_authorization Example The following example shows how one would (pre) authorize a payment of $100 on a sample card . iex&gt; card = % CreditCard { number : &quot;4567350000427977&quot; , month : 12 , year : 43 , first_name : &quot;John&quot; , last_name : &quot;Doe&quot; , verification_code : &quot;123&quot; , brand : &quot;VISA&quot; } iex&gt; amount = Money . new ( 100 , :USD ) iex&gt; { :ok , auth_result } = Gringotts . authorize ( Gringotts.Gateways.GlobalCollect , amount , card , opts )","ref":"Gringotts.Gateways.GlobalCollect.html#authorize/3","title":"Gringotts.Gateways.GlobalCollect.authorize/3","type":"function"},{"doc":"Captures a pre-authorized amount . amount used in the pre-authorization referenced by payment_id is transferred to the merchant account by GlobalCollect. Note Authorized payment with PENDING_APPROVAL status only allow a single capture whereas the one with PENDING_CAPTURE status is used for payments that allow multiple captures. Example The following example shows how one would (partially) capture a previously authorized a payment worth $100 by referencing the obtained authorization id . iex&gt; amount = Money . new ( 100 , :USD ) iex&gt; { :ok , capture_result } = Gringotts . capture ( Gringotts.Gateways.GlobalCollect , auth_result . authorization , amount , opts )","ref":"Gringotts.Gateways.GlobalCollect.html#capture/3","title":"Gringotts.Gateways.GlobalCollect.capture/3","type":"function"},{"doc":"Transfers amount from the customer to the merchant. GlobalCollect attempts to process a purchase on behalf of the customer, by debiting amount from the customer's account by charging the customer's card . Example The following example shows how one would process a payment in one-shot, without (pre) authorization. iex&gt; card = % CreditCard { number : &quot;4567350000427977&quot; , month : 12 , year : 43 , first_name : &quot;John&quot; , last_name : &quot;Doe&quot; , verification_code : &quot;123&quot; , brand : &quot;VISA&quot; } iex&gt; amount = Money . new ( 100 , :USD ) iex&gt; { :ok , purchase_result } = Gringotts . purchase ( Gringotts.Gateways.GlobalCollect , amount , card , opts )","ref":"Gringotts.Gateways.GlobalCollect.html#purchase/3","title":"Gringotts.Gateways.GlobalCollect.purchase/3","type":"function"},{"doc":"Refunds the amount to the customer's account with reference to a prior transfer. You always have the option to refund just a portion of the payment amount. It is also possible to submit multiple refund requests on one payment as long as the total amount to be refunded does not exceed the total amount that was paid. Example The following example shows how one would refund a previous purchase (and similarily for captures). iex&gt; amount = Money . new ( 100 , :USD ) iex&gt; { :ok , refund_result } = Gringotts . refund ( Gringotts.Gateways.GlobalCollect , auth_result . authorization , amount )","ref":"Gringotts.Gateways.GlobalCollect.html#refund/3","title":"Gringotts.Gateways.GlobalCollect.refund/3","type":"function"},{"doc":"Catches gateway configuration errors. Raises a run-time ArgumentError if any of the required_config values is not available or missing from the Application config.","ref":"Gringotts.Gateways.GlobalCollect.html#validate_config/1","title":"Gringotts.Gateways.GlobalCollect.validate_config/1","type":"function"},{"doc":"Voids the referenced payment. This makes it impossible to process the payment any further and will also try to reverse an authorization on a card. Reversing an authorization that you will not be utilizing will prevent you from having to pay a fee/penalty for unused authorization requests. Example The following example shows how one would void a previous (pre) authorization. Remember that our capture/3 example only did a complete capture. iex&gt; { :ok , void_result } = Gringotts . void ( Gringotts.Gateways.GlobalCollect , auth_result . authorization , opts )","ref":"Gringotts.Gateways.GlobalCollect.html#void/2","title":"Gringotts.Gateways.GlobalCollect.void/2","type":"function"},{"doc":"MONEI gateway implementation. For reference see MONEI's API (v1) documentation . The following features of MONEI are implemented: Action Method type Pre-authorize authorize/3 PA Capture capture/3 CP Refund refund/3 RF Reversal void/2 RV Debit purchase/3 DB Tokenization / Registrations store/2 What's this last column type ? That's the paymentType of the request, which you can ignore unless you'd like to contribute to this module. Please read the MONEI Guides . The opts argument Most Gringotts API calls accept an optional keyword list opts to supply optional arguments for transactions with the MONEI gateway. The following keys are supported: Key Remark billing Address of the customer, which can be used for AVS risk check. cart Not Implemented custom It's a map of &quot;name&quot;-&quot;value&quot; pairs, and all of it is echoed back in the response. customer Annotate transactions with customer info on your Monei account, and helps in risk management. invoice_id Merchant provided invoice identifier, must be unique per transaction with Monei. transaction_id Merchant provided token for a transaction, must be unique per transaction with Monei. category The category of the transaction. merchant Information about the merchant, which overrides the cardholder's bank statement. register Also store payment data included in this request for future use. shipping Location of recipient of goods, for logistics. shipping_customer Recipient details, could be different from customer . Registering your MONEI account at Gringotts After making an account on MONEI , head to the dashboard and find your account &quot;secrets&quot; in the Sub-Accounts &gt; Overview section. Here's how the secrets map to the required configuration parameters for MONEI: Config parameter MONEI secret :userId User ID :entityId Channel ID :password Password Your Application config must include the :userId , :entityId , :password fields and would look something like this: config :gringotts , Gringotts.Gateways.Monei , userId : &quot;your_secret_user_id&quot; , password : &quot;your_secret_password&quot; , entityId : &quot;your_secret_channel_id&quot; Scope of this module You, the merchant needs to be PCI-DSS Compliant if you wish to use this module. Your server will recieve sensitive card and customer information. MONEI does not process money in cents, and the amount is rounded to 2 decimal places. Although MONEI supports payments from various cards , banks and virtual accounts (like some wallets), this library only accepts payments by (supported) cards . Supported countries MONEI supports the countries listed here Supported currencies MONEI supports the currecncies listed here , and this module supports a subset of those: :AED , :AFN , :ANG , :AOA , :AWG , :AZN , :BAM , :BGN , :BRL , :BYN , :CDF , :CHF , :CUC , :EGP , :EUR , :GBP , :GEL , :GHS , :MDL , :MGA , :MKD , :MWK , :MZN , :NAD , :NGN , :NIO , :NOK , :NPR , :NZD , :PAB , :PEN , :PGK , :PHP , :PKR , :PLN , :PYG , :QAR , :RSD , :RUB , :RWF , :SAR , :SCR , :SDG , :SEK , :SGD , :SHP , :SLL , :SOS , :SRD , :STD , :SYP , :SZL , :THB , :TJS , :TOP , :TRY , :TTD , :TWD , :TZS , :UAH , :UGX , :USD , :UYU , :UZS , :VND , :VUV , :WST , :XAF , :XCD , :XOF , :XPF , :YER , :ZAR , :ZMW , :ZWL Please raise an issue if you'd like us to add support for more currencies Following the examples First, set up a sample application and configure it to work with MONEI. You could do that from scratch by following our Getting Started guide. To save you time, we recommend cloning our example repo that gives you a pre-configured sample app ready-to-go. You could use the same config or update it the with your &quot;secrets&quot; that you see in Dashboard &gt; Sub-accounts as described above . To save a lot of time, create a .iex.exs file as shown in this gist to introduce a set of handy bindings and aliases. We'll be using these bindings in the examples below. TODO Backoffice operations Credit Rebill Recurring payments Reporting","ref":"Gringotts.Gateways.Monei.html","title":"Gringotts.Gateways.Monei","type":"module"},{"doc":"Performs a (pre) Authorize operation. The authorization validates the card details with the banking network, places a hold on the transaction amount in the customer’s issuing bank and also triggers risk management. Funds are not transferred. MONEI returns an ID string which can be used to: capture/3 an amount. void/2 a pre-authorization. Note The :register option when set to true will store this card for future use, and you will recieve a registration token in the :token field of the Response struct. A stand-alone pre-authorization expires in 72hrs . Example The following example shows how one would (pre) authorize a payment of $42 on a sample card . iex&gt; amount = Money . new ( 42 , :USD ) iex&gt; card = % Gringotts.CreditCard { first_name : &quot;Harry&quot; , last_name : &quot;Potter&quot; , number : &quot;4200000000000000&quot; , year : 2099 , month : 12 , verification_code : &quot;123&quot; , brand : &quot;VISA&quot; } iex&gt; { :ok , auth_result } = Gringotts . authorize ( Gringotts.Gateways.Monei , amount , card , opts ) iex&gt; auth_result . id # This is the authorization ID iex&gt; auth_result . token # This is the registration ID/token","ref":"Gringotts.Gateways.Monei.html#authorize/3","title":"Gringotts.Gateways.Monei.authorize/3","type":"function"},{"doc":"Captures a pre-authorized amount . amount is transferred to the merchant account by MONEI when it is smaller or equal to the amount used in the pre-authorization referenced by payment_id . Note MONEI allows partial captures and unlike many other gateways, does not release the remaining amount back to the payment source. Thus, the same pre-authorisation ID can be used to perform multiple captures, till: all the pre-authorized amount is captured or, the remaining amount is explicitly &quot;reversed&quot; via void/2 . [citation-needed] Example The following example shows how one would (partially) capture a previously authorized a payment worth $35 by referencing the obtained authorization id . iex&gt; amount = Money . new ( 35 , :USD ) iex&gt; { :ok , capture_result } = Gringotts . capture ( Gringotts.Gateways.Monei , amount , auth_result . id , opts )","ref":"Gringotts.Gateways.Monei.html#capture/3","title":"Gringotts.Gateways.Monei.capture/3","type":"function"},{"doc":"Transfers amount from the customer to the merchant. MONEI attempts to process a purchase on behalf of the customer, by debiting amount from the customer's account by charging the customer's card . Note The :register option when set to true will store this card for future use, and you will recieve a registration token in the :token field of the Response struct. Example The following example shows how one would process a payment worth $42 in one-shot, without (pre) authorization. iex&gt; amount = Money . new ( 42 , :USD ) iex&gt; card = % Gringotts.CreditCard { first_name : &quot;Harry&quot; , last_name : &quot;Potter&quot; , number : &quot;4200000000000000&quot; , year : 2099 , month : 12 , verification_code : &quot;123&quot; , brand : &quot;VISA&quot; } iex&gt; { :ok , purchase_result } = Gringotts . purchase ( Gringotts.Gateways.Monei , amount , card , opts ) iex&gt; purchase_result . token # This is the registration ID/token","ref":"Gringotts.Gateways.Monei.html#purchase/3","title":"Gringotts.Gateways.Monei.purchase/3","type":"function"},{"doc":"Refunds the amount to the customer's account with reference to a prior transfer. MONEI processes a full or partial refund worth amount , referencing a previous purchase/3 or capture/3 . The end customer will always see two bookings/records on his statement. Refer MONEI's Backoffice Operations guide. Example The following example shows how one would (completely) refund a previous purchase (and similarily for captures). iex&gt; amount = Money . new ( 42 , :USD ) iex&gt; { :ok , refund_result } = Gringotts . refund ( Gringotts.Gateways.Monei , purchase_result . id , amount )","ref":"Gringotts.Gateways.Monei.html#refund/3","title":"Gringotts.Gateways.Monei.refund/3","type":"function"},{"doc":"Stores the payment-source data for later use. MONEI can store the payment-source details, for example card or bank details which can be used to effectively process One-Click and Recurring payments, and return a registration token for reference. The registration token is available in the Response.id field. It is recommended to associate these details with a &quot;Customer&quot; by passing customer details in the opts . Note One-Click and Recurring payments are currently not implemented. Payment details can be saved during a purchase/3 or capture/3 . Example The following example shows how one would store a card (a payment-source) for future use. iex&gt; card = % Gringotts.CreditCard { first_name : &quot;Harry&quot; , last_name : &quot;Potter&quot; , number : &quot;4200000000000000&quot; , year : 2099 , month : 12 , verification_code : &quot;123&quot; , brand : &quot;VISA&quot; } iex&gt; { :ok , store_result } = Gringotts . store ( Gringotts.Gateways.Monei , card ) iex&gt; store_result . id # This is the registration token","ref":"Gringotts.Gateways.Monei.html#store/2","title":"Gringotts.Gateways.Monei.store/2","type":"function"},{"doc":"WIP MONEI unstore does not seem to work. MONEI always returns a 403 Deletes previously stored payment-source data.","ref":"Gringotts.Gateways.Monei.html#unstore/2","title":"Gringotts.Gateways.Monei.unstore/2","type":"function"},{"doc":"Catches gateway configuration errors. Raises a run-time ArgumentError if any of the required_config values is not available or missing from the Application config.","ref":"Gringotts.Gateways.Monei.html#validate_config/1","title":"Gringotts.Gateways.Monei.validate_config/1","type":"function"},{"doc":"Voids the referenced payment. This method attempts a reversal of the either a previous purchase/3 , capture/3 or authorize/3 referenced by payment_id . As a consequence, the customer will never see any booking on his statement. Refer MONEI's Backoffice Operations guide. Voiding a previous authorization MONEI will reverse the authorization by sending a &quot;reversal request&quot; to the payment source (card issuer) to clear the funds held against the authorization. If some of the authorized amount was captured, only the remaining amount is cleared. [citation-needed] Voiding a previous purchase MONEI will reverse the payment, by sending all the amount back to the customer. Note that this is not the same as refund/3 . Example The following example shows how one would void a previous (pre) authorization. Remember that our capture/3 example only did a partial capture. iex&gt; { :ok , void_result } = Gringotts . void ( Gringotts.Gateways.Monei , auth_result . id , opts )","ref":"Gringotts.Gateways.Monei.html#void/2","title":"Gringotts.Gateways.Monei.void/2","type":"function"},{"doc":"openpay gateway implementation. For reference see openpay documentation . The following features of openpay are implemented: Action Method Pre-authorize authorize/3 Capture capture/3 Purchase purchase/3 Reversal void/2 Refund refund/3 The opts argument Most Gringotts API calls accept an optional keyword list opts to supply optional arguments for transactions with the mercadopago gateway. The following keys are supported: Key Remark email Email of the customer. Type - string device_session_id Identifier of the device generated by the antifraud tool. Type- string method It must contain the card value in order to specify the charge will be made from card. Type- string address Address of the card owner. Type object phone_number Customer phone number. Type- integer Registering your openpay account at Gringotts After making an account on openpay , find your account &quot;secrets&quot; in the home page Here's how the secrets map to the required configuration parameters for openpay: Config parameter openpay secret :merchant_id MerchantId :public_key PublicKey Your Application config must include the [:merchant_id, :public_key] field(s) and would look something like this: config :gringotts , Gringotts.Gateways.Openpay , merchant_id : &quot;your_secret_merchant_id&quot; public_key : &quot;your_secret_public_key&quot; Note mercadopago processes money with upto two decimal places. Supported currencies and countries openpay support mexico country and :MXN currency. Following the examples First, set up a sample application and configure it to work with openpay. You could do that from scratch by following our Getting Started guide. To save you time, we recommend cloning our example repo that gives you a pre-configured sample app ready-to-go. You could use the same config or update it the with your &quot;secrets&quot; as described above . Run an iex session with iex -S mix and add some variable bindings and aliases to it (to save some time):","ref":"Gringotts.Gateways.Openpay.html","title":"Gringotts.Gateways.Openpay","type":"module"},{"doc":"Performs a (pre) Authorize operation. The authorization validates the card details with the banking network, places a hold on the transaction amount in the customer’s issuing bank and also triggers risk management. Funds are not transferred. openpay returns an ID string which can be used to: capture/3 an amount. void/2 a pre-authorization. Example The following example shows how one would (pre) authorize a payment of $42 on a sample card . iex&gt; amount = Money . new ( 42 , :MXN ) iex&gt; card = % Gringotts.CreditCard { first_name : &quot;Harry&quot; , last_name : &quot;Potter&quot; , number : &quot;4200000000000000&quot; , year : 2099 , month : 12 , verification_code : &quot;123&quot; , brand : &quot;VISA&quot; } iex&gt; { :ok , auth_result } = Gringotts . authorize ( Gringotts.Gateways.Openpay , amount , card , opts ) iex&gt; auth_result . id # This is the authorization ID","ref":"Gringotts.Gateways.Openpay.html#authorize/3","title":"Gringotts.Gateways.Openpay.authorize/3","type":"function"},{"doc":"Captures a pre-authorized amount . amount is transferred to the merchant account by openpay when it is smaller or equal to the amount used in the pre-authorization referenced by payment_id . Note openpay allows partial captures and unlike many other gateways, does not release the remaining amount back to the payment source. Thus, the same pre-authorisation ID can be used to perform multiple captures, till: all the pre-authorized amount is captured or, the remaining amount is explicitly &quot;reversed&quot; via void/2 . Example The following example shows how one would (partially) capture a previously authorized a payment worth $35 by referencing the obtained authorization id . iex&gt; amount = Money . new ( 35 , :MXN ) iex&gt; { :ok , capture_result } = Gringotts . capture ( Gringotts.Gateways.Openpay , amount , auth_result . id , opts )","ref":"Gringotts.Gateways.Openpay.html#capture/3","title":"Gringotts.Gateways.Openpay.capture/3","type":"function"},{"doc":"Transfers amount from the customer to the merchant. openpay attempts to process a purchase on behalf of the customer, by debiting amount from the customer's account by charging the customer's card . Example The following example shows how one would process a payment worth $42 in one-shot, without (pre) authorization. iex&gt; amount = Money . new ( 42 , :MXN ) iex&gt; card = % Gringotts.CreditCard { first_name : &quot;Harry&quot; , last_name : &quot;Potter&quot; , number : &quot;4200000000000000&quot; , year : 2099 , month : 12 , verification_code : &quot;123&quot; , brand : &quot;VISA&quot; } iex&gt; { :ok , purchase_result } = Gringotts . purchase ( Gringotts.Gateways.Openpay , amount , card , opts )","ref":"Gringotts.Gateways.Openpay.html#purchase/3","title":"Gringotts.Gateways.Openpay.purchase/3","type":"function"},{"doc":"Refunds the amount to the customer's account with reference to a prior transfer. openpay processes a full or partial refund worth amount , referencing a previous purchase/3 or capture/3 . Example The following example shows how one would (completely) refund a previous purchase (and similarily for captures). iex&gt; amount = Money . new ( 42 , :MXN ) iex&gt; { :ok , refund_result } = Gringotts . refund ( Gringotts.Gateways.Openpay , purchase_result . id , amount )","ref":"Gringotts.Gateways.Openpay.html#refund/3","title":"Gringotts.Gateways.Openpay.refund/3","type":"function"},{"doc":"Catches gateway configuration errors. Raises a run-time ArgumentError if any of the required_config values is not available or missing from the Application config.","ref":"Gringotts.Gateways.Openpay.html#validate_config/1","title":"Gringotts.Gateways.Openpay.validate_config/1","type":"function"},{"doc":"Voids the referenced payment. This method attempts a reversal of a previous transaction referenced by payment_id . As a consequence, the customer will never see any booking on his statement. Note Only pending or in_process payments can be cancelled. Cancelled coupon payments, deposits and/or transfers will be deposited in the buyer’s Openpay account. Example The following example shows how one would void iex&gt; {:ok, void_result} = Gringotts.void(Gringotts.Gateways.Openpay, auth_result.id, opts)","ref":"Gringotts.Gateways.Openpay.html#void/2","title":"Gringotts.Gateways.Openpay.void/2","type":"function"},{"doc":"PAYMILL gateway implementation. For refernce see PAYMILL's API (v2.1) documentation . The following features of PAYMILL are implemented: Action Method Authorize authorize/3 Capture capture/3 Purchase purchase/3 Refund refund/3 Void void/2 The opts argument Most Gringotts API calls accept an optional keyword list opts to supply optional arguments for transactions with the PAYMILL gateway. Currently, no optional params are supported. Registering your PAYMILL account at Gringotts After making an account on PAYMILL , head to the dashboard and find your account &quot;secrets&quot;. Here's how the secrets map to the required configuration parameters for PAYMILL: Config parameter PAYMILL secret :private_key Private Key :public_key Public Key Your Application config must include the :private_key , :public_key fields and would look something like this: config :gringotts , Gringotts.Gateways.Paymill , private_key : &quot;your_secret_private_key&quot; , public_key : &quot;your_secret_public_key&quot; Scope of this module PAYMILL processes money in the sub-divided unit of currency (ie, in case of USD it works in cents). This module does not offer direct API integration for PCI DSS compliant merchants. Hence, you can use this module even if your infrastructure (servers) are not PCI-DSS compliant! To use their product, a merchant (aka user of this library) would have to use their Bridge (js integration) (or equivalent) in your application frontend to collect Credit/Debit Card data. This would obtain a unique card_token at the client-side which can be used by this module for various operations like authorize/3 and purchase/3 . Supported countries As a PAYMILL merchant you can accept payments from around the globe. For more details refer to Paymill country support . Supported currencies Your transactions will be processed in your native currency. For more information refer to Paymill currency support . Following the examples First, set up a sample application and configure it to work with PAYMILL. You could do that from scratch by following our Getting Started guide. To save you time, we recommend cloning our example repo that gives you a pre-configured sample app ready-to-go. You could use the same config or update it the with your &quot;secrets&quot; as described above . Run an iex session with iex -S mix and add some variable bindings and aliases to it (to save some time): iex&gt; alias Gringotts . { Response , CreditCard , Gateways.Paymill } iex&gt; amount = Money . new ( 4200 , :EUR ) We'll be using these in the examples below.","ref":"Gringotts.Gateways.Paymill.html","title":"Gringotts.Gateways.Paymill","type":"module"},{"doc":"Performs a (pre) Authorize operation. The authorization validates the card details for token with the banking network, places a hold on the transaction amount in the customer’s issuing bank and also triggers risk management. Funds are not transferred. The authorization token is available in the Response.id field. Example The following example shows how one would (pre) authorize a payment of €42 on a sample token . iex&gt; amount = Money . new ( 4200 , :EUR ) iex&gt; card_token = &quot;tok_XXXXXXXXXXXXXXXXXXXXXXXXXXXX&quot; iex&gt; { :ok , auth_result } = Gringotts . authorize ( Gringotts.Gateways.Paymill , amount , card_token , opts ) iex&gt; auth_result . id # This is the preauth-id","ref":"Gringotts.Gateways.Paymill.html#authorize/3","title":"Gringotts.Gateways.Paymill.authorize/3","type":"function"},{"doc":"Captures a pre-authorized amount . amount is transferred to the merchant account by PAYMILL when it is smaller or equal to the amount used in the pre-authorization referenced by preauth_id . Note PAYMILL allows partial captures and unlike many other gateways, and releases any remaining amount back to the payment source. Thus, the same pre-authorisation ID cannot be used to perform multiple captures. Example The following example shows how one would (partially) capture a previously authorized a payment worth €42 by referencing the obtained authorization id . iex&gt; amount = Money . new ( 4200 , :EUR ) iex&gt; preauth_id = auth_result . id # preauth_id = &quot;some_authorization_id&quot; iex&gt; Gringotts . capture ( Gringotts.Gateways.Paymill , preauth_id , amount , opts )","ref":"Gringotts.Gateways.Paymill.html#capture/3","title":"Gringotts.Gateways.Paymill.capture/3","type":"function"},{"doc":"Transfers amount from the customer to the merchant. PAYMILL attempts to process a purchase on behalf of the customer, by debiting amount from the customer's account by charging the customer's card via token . Example The following example shows how one would process a payment worth €42 in one-shot, without (pre) authorization. iex&gt; amount = Money . new ( 4200 , :EUR ) iex&gt; token = &quot;tok_XXXXXXXXXXXXXXXXXXXXXXXXXXXX&quot; iex&gt; { :ok , purchase_result } = Gringotts . purchase ( Gringotts.Gateways.Paymill , amount , token , opts )","ref":"Gringotts.Gateways.Paymill.html#purchase/3","title":"Gringotts.Gateways.Paymill.purchase/3","type":"function"},{"doc":"Refunds the amount to the customer's account with reference to a prior transfer. PAYMILL processes a full or partial refund worth amount , where transaction_id references a previous purchase/3 or capture/3 result. Multiple partial refunds are allowed on the same transaction_id till all the captured/purchased amount has been refunded. Example The following example shows how one would refund a previous purchase (and similarily for captures). iex&gt; transaction_id = purchase_result . id iex&gt; amount = Money . new ( 4200 , :EUR ) iex&gt; Gringotts . refund ( Gringotts.Gateways.Paymill , amount , transaction_id )","ref":"Gringotts.Gateways.Paymill.html#refund/3","title":"Gringotts.Gateways.Paymill.refund/3","type":"function"},{"doc":"Catches gateway configuration errors. Raises a run-time ArgumentError if any of the required_config values is not available or missing from the Application config.","ref":"Gringotts.Gateways.Paymill.html#validate_config/1","title":"Gringotts.Gateways.Paymill.validate_config/1","type":"function"},{"doc":"Voids the referenced authorization. Attempts a reversal of the a previous authorize/3 referenced by preauth_id . Example The following example shows how one would void a previous authorization. iex&gt; preauth_id = auth_result . id iex&gt; Gringotts . void ( Gringotts.Gateways.Paymill , preauth_id )","ref":"Gringotts.Gateways.Paymill.html#void/2","title":"Gringotts.Gateways.Paymill.void/2","type":"function"},{"doc":"Stripe gateway implementation. For reference see Stripe's API documentation . The following features of Stripe are implemented: Action Method Pre-authorize authorize/3 Capture capture/3 Refund refund/3 Reversal void/2 Debit purchase/3 Store store/2 Unstore unstore/2 The opts argument Most Gringotts API calls accept an optional Keyword list opts to supply optional arguments for transactions with the Stripe gateway. The following keys are supported: Key Status currency Implemented capture Implemented description Implemented metadata Implemented receipt_email Implemented shipping Implemented customer Implemented source Implemented statement_descriptor Implemented charge Implemented reason Implemented account_balance Not implemented business_vat_id Not implemented coupon Not implemented default_source Not implemented email Not implemented shipping Not implemented Note This module can be used by both PCI-DSS compliant as well as non-compliant merchants! I'm not PCI-DSS compliant No worries, both authorize/3 and purchase/3 accept a &quot;payment-source-identifier&quot; (a string ) instead of a CreditCard.t struct. You'll have to generate this identifier using Stripe.js and Elements client-side. I'm PCI-DSS compliant In that case, you need not use Stripe.js or Elements and can directly accept the client's card info and pass the CreditCard.t struct to this module's functions. Registering your Stripe account at Gringotts After making an account on Stripe , head to the dashboard and find your account secrets in the API section. Here's how the secrets map to the required configuration parameters for Stripe: Config parameter Stripe secret :secret_key Secret key Your Application config must look something like this: config :gringotts , Gringotts.Gateways.Stripe , secret_key : &quot;your_secret_key&quot; , default_currency : &quot;usd&quot;","ref":"Gringotts.Gateways.Stripe.html","title":"Gringotts.Gateways.Stripe","type":"module"},{"doc":"Performs a (pre) Authorize operation. The authorization validates the card details with the banking network, places a hold on the transaction amount in the customer’s issuing bank and also triggers risk management. Funds are not transferred. Stripe returns an charge_id which should be stored at your side and can be used later to: capture/3 an amount. void/2 a pre-authorization. Note Uncaptured charges expire in 7 days. For more information, see authorizing charges and settling later . Example The following session shows how one would (pre) authorize a payment of $10 on a sample card . iex&gt; card = % CreditCard { first_name : &quot;John&quot; , last_name : &quot;Smith&quot; , number : &quot;4242424242424242&quot; , year : &quot;2017&quot; , month : &quot;12&quot; , verification_code : &quot;123&quot; } address = % Address { street1 : &quot;123 Main&quot; , city : &quot;New York&quot; , region : &quot;NY&quot; , country : &quot;US&quot; , postal_code : &quot;11111&quot; } iex&gt; opts = [ currency : &quot;usd&quot; , address : address ] iex&gt; amount = 10 iex&gt; Gringotts . authorize ( Gringotts.Gateways.Stripe , amount , card , opts )","ref":"Gringotts.Gateways.Stripe.html#authorize/3","title":"Gringotts.Gateways.Stripe.authorize/3","type":"function"},{"doc":"Captures a pre-authorized amount. Amount is transferred to the merchant account by Stripe when it is smaller or equal to the amount used in the pre-authorization referenced by charge_id . Note Stripe allows partial captures and release the remaining amount back to the payment source. Thus, the same pre-authorisation charge_id cannot be used to perform multiple captures. Example The following session shows how one would (partially) capture a previously authorized a payment worth $10 by referencing the obtained charge_id . iex&gt; id = &quot;ch_1BYvGkBImdnrXiZwet3aKkQE&quot; iex&gt; amount = 5 iex&gt; opts = [ ] iex&gt; Gringotts . capture ( Gringotts.Gateways.Stripe , id , amount , opts )","ref":"Gringotts.Gateways.Stripe.html#capture/3","title":"Gringotts.Gateways.Stripe.capture/3","type":"function"},{"doc":"Transfers amount from the customer to the merchant. Stripe attempts to process a purchase on behalf of the customer, by debiting amount from the customer's account by charging the customer's card. Example The following session shows how one would process a payment in one-shot, without (pre) authorization. iex&gt; card = % CreditCard { first_name : &quot;John&quot; , last_name : &quot;Smith&quot; , number : &quot;4242424242424242&quot; , year : &quot;2017&quot; , month : &quot;12&quot; , verification_code : &quot;123&quot; } address = % Address { street1 : &quot;123 Main&quot; , city : &quot;New York&quot; , region : &quot;NY&quot; , country : &quot;US&quot; , postal_code : &quot;11111&quot; } iex&gt; opts = [ currency : &quot;usd&quot; , address : address ] iex&gt; amount = 5 iex&gt; Gringotts . purchase ( Gringotts.Gateways.Stripe , amount , card , opts )","ref":"Gringotts.Gateways.Stripe.html#purchase/3","title":"Gringotts.Gateways.Stripe.purchase/3","type":"function"},{"doc":"Refunds the amount to the customer's card with reference to a prior transfer. Stripe processes a full or partial refund worth amount , referencing a previous purchase/3 or capture/3 . Example The following session shows how one would refund a previous purchase (and similarily for captures). iex&gt; amount = 5 iex&gt; id = &quot;ch_1BYvGkBImdnrXiZwet3aKkQE&quot; iex&gt; opts = [ ] iex&gt; Gringotts . refund ( Gringotts.Gateways.Stripe , amount , id , opts )","ref":"Gringotts.Gateways.Stripe.html#refund/3","title":"Gringotts.Gateways.Stripe.refund/3","type":"function"},{"doc":"Stores the payment-source data for later use. Stripe can store the payment-source details, for example card which can be used to effectively to process One-Click and Recurring_ payments, and return a customer_id for reference. Example The following session shows how one would store a card (a payment-source) for future use. iex&gt; card = % CreditCard { first_name : &quot;John&quot; , last_name : &quot;Smith&quot; , number : &quot;4242424242424242&quot; , year : &quot;2017&quot; , month : &quot;12&quot; , verification_code : &quot;123&quot; } address = % Address { street1 : &quot;123 Main&quot; , city : &quot;New York&quot; , region : &quot;NY&quot; , country : &quot;US&quot; , postal_code : &quot;11111&quot; } iex&gt; opts = [ address : address ] iex&gt; Gringotts . store ( Gringotts.Gateways.Stripe , card , opts )","ref":"Gringotts.Gateways.Stripe.html#store/2","title":"Gringotts.Gateways.Stripe.store/2","type":"function"},{"doc":"Deletes previously stored payment-source data. Deletes the already stored payment source, so that it cannot be used again for capturing payments. Examples The following session shows how one would unstore a already stored payment source. iex&gt; id = &quot;cus_BwpLX2x4ecEUgD&quot; iex&gt; Gringotts . unstore ( Gringotts.Gateways.Stripe , id , opts )","ref":"Gringotts.Gateways.Stripe.html#unstore/2","title":"Gringotts.Gateways.Stripe.unstore/2","type":"function"},{"doc":"Catches gateway configuration errors. Raises a run-time ArgumentError if any of the required_config values is not available or missing from the Application config.","ref":"Gringotts.Gateways.Stripe.html#validate_config/1","title":"Gringotts.Gateways.Stripe.validate_config/1","type":"function"},{"doc":"Voids the referenced payment. This method attempts a reversal of the either a previous purchase/3 or authorize/3 referenced by charge_id . As a consequence, the customer will never see any booking on his statement. Voiding a previous authorization Stripe will reverse the authorization by sending a &quot;reversal request&quot; to the payment source (card issuer) to clear the funds held against the authorization. Voiding a previous purchase Stripe will reverse the payment, by sending all the amount back to the customer. Note that this is not the same as refund/3 . Example The following session shows how one would void a previous (pre) authorization. Remember that our capture/3 example only did a partial capture. iex&gt; id = &quot;ch_1BYvGkBImdnrXiZwet3aKkQE&quot; iex&gt; opts = [ ] iex&gt; Gringotts . void ( Gringotts.Gateways.Stripe , id , opts )","ref":"Gringotts.Gateways.Stripe.html#void/2","title":"Gringotts.Gateways.Stripe.void/2","type":"function"},{"doc":"Trexle Payment Gateway implementation. For further details, please refer Trexle API documentation . Following are the features that have been implemented for the Trexle Gateway: Action Method Authorize authorize/3 Purchase purchase/3 Capture capture/3 Refund refund/3 Store store/2 PCI compliance is mandatory! You, the merchant needs to be PCI-DSS Compliant if you wish to use this module! Your server will recieve sensitive card and customer information. The opts argument Most Gringotts API calls accept an optional keyword list opts to supply optional arguments for transactions with Trexle. The following keys are supported: email ip_address description Registering your Trexle account at Gringotts After creating your account successfully on Trexle, head to the dashboard and find your account &quot;secrets&quot; in the API keys section. Here's how the secrets map to the required configuration parameters for Trexle: Config parameter Trexle secret :api_key API key Your Application config must look something like this: config :gringotts , Gringotts.Gateways.Trexle , api_key : &quot;your-secret-API-key&quot; Scope of this module Trexle processes money in cents. citation-needed . Supported Gateways Find the official list here . Following the examples First, set up a sample application and configure it to work with Trexle. You could do that from scratch by following our Getting Started guide. To save you time, we recommend cloning our example repo that gives you a pre-configured sample app ready-to-go. You could use the same config or update it the with your &quot;secrets&quot; that as described above . To save a lot of time, create a .iex.exs file as shown in this gist to introduce a set of handy bindings and aliases. We'll be using these bindings in the examples below.","ref":"Gringotts.Gateways.Trexle.html","title":"Gringotts.Gateways.Trexle","type":"module"},{"doc":"Performs a (pre) Authorize operation. The authorization validates the card details with the banking network, places a hold on the transaction amount in the customer’s issuing bank and also triggers risk management. Funds are not transferred. Trexle returns a &quot;charge token&quot;, avaliable in the Response.id field, which can be used in future to perform a capture/3 . Example The following session shows how one would (pre) authorize a payment of $100 on a sample card . iex&gt; amount = Money . new ( 100 , :USD ) iex&gt; card = % CreditCard { first_name : &quot;Harry&quot; , last_name : &quot;Potter&quot; , number : &quot;5200828282828210&quot; , year : 2099 , month : 12 , verification_code : &quot;123&quot; , brand : &quot;VISA&quot; } iex&gt; address = % Address { street1 : &quot;301, Gryffindor&quot; , street2 : &quot;Hogwarts School of Witchcraft and Wizardry, Hogwarts Castle&quot; , city : &quot;Highlands&quot; , region : &quot;SL&quot; , country : &quot;GB&quot; , postal_code : &quot;11111&quot; , phone : &quot;(555)555-5555&quot; } iex&gt; options = [ email : &quot;masterofdeath@ministryofmagic.gov&quot; , ip_address : &quot;127.0.0.1&quot; , billing_address : address , description : &quot;For our valued customer, Mr. Potter&quot; ] iex&gt; Gringotts . authorize ( Gringotts.Gateways.Trexle , amount , card , options )","ref":"Gringotts.Gateways.Trexle.html#authorize/3","title":"Gringotts.Gateways.Trexle.authorize/3","type":"function"},{"doc":"Captures a pre-authorized amount . amount is transferred to the merchant account by Trexle when it is smaller or equal to the amount used in the pre-authorization referenced by charge_token . Trexle returns a &quot;charge token&quot;, avaliable in the Response.id field, which can be used in future to perform a refund/2 . Note Multiple captures cannot be performed on the same &quot;charge token&quot;. If the captured amount is smaller than the (pre) authorized amount, the &quot;un-captured&quot; amount is released. citation-needed Example The following example shows how one would (partially) capture a previously authorized a payment worth $10 by referencing the obtained charge_token . iex&gt; amount = Money . new ( 10 , :USD ) iex&gt; token = &quot;some-real-token&quot; iex&gt; Gringotts . capture ( Gringotts.Gateways.Trexle , token , amount )","ref":"Gringotts.Gateways.Trexle.html#capture/3","title":"Gringotts.Gateways.Trexle.capture/3","type":"function"},{"doc":"Transfers amount from the customer to the merchant. Trexle attempts to process a purchase on behalf of the customer, by debiting amount from the customer's account by charging the customer's card . Example The following session shows how one would process a payment worth $100 in one-shot, without (pre) authorization. iex&gt; amount = Money . new ( 100 , :USD ) iex&gt; card = % CreditCard { first_name : &quot;Harry&quot; , last_name : &quot;Potter&quot; , number : &quot;5200828282828210&quot; , year : 2099 , month : 12 , verification_code : &quot;123&quot; , brand : &quot;VISA&quot; } iex&gt; address = % Address { street1 : &quot;301, Gryffindor&quot; , street2 : &quot;Hogwarts School of Witchcraft and Wizardry, Hogwarts Castle&quot; , city : &quot;Highlands&quot; , region : &quot;SL&quot; , country : &quot;GB&quot; , postal_code : &quot;11111&quot; , phone : &quot;(555)555-5555&quot; } iex&gt; options = [ email : &quot;masterofdeath@ministryofmagic.gov&quot; , ip_address : &quot;127.0.0.1&quot; , billing_address : address , description : &quot;For our valued customer, Mr. Potter&quot; ] iex&gt; Gringotts . purchase ( Gringotts.Gateways.Trexle , amount , card , options )","ref":"Gringotts.Gateways.Trexle.html#purchase/3","title":"Gringotts.Gateways.Trexle.purchase/3","type":"function"},{"doc":"Refunds the amount to the customer's card with reference to a prior transfer. Trexle processes a full or partial refund worth amount , referencing a previous purchase/3 or capture/3 . Trexle returns a &quot;refund token&quot;, avaliable in the Response.id field. Multiple, partial refunds can be performed on the same &quot;charge token&quot; referencing a previous purchase/3 or capture/3 till the cumulative refunds equals the capture/3 d or purchase/3 d amount. Example The following session shows how one would refund $100 of a previous purchase/3 (and similarily for capture/3 s). iex&gt; amount = Money . new ( 100 , :USD ) iex&gt; token = &quot;some-real-token&quot; iex&gt; Gringotts . refund ( Gringotts.Gateways.Trexle , amount , token )","ref":"Gringotts.Gateways.Trexle.html#refund/3","title":"Gringotts.Gateways.Trexle.refund/3","type":"function"},{"doc":"Stores the card information for future use. Example The following session shows how one would store a card (a payment-source) for future use. iex&gt; card = % CreditCard { first_name : &quot;Harry&quot; , last_name : &quot;Potter&quot; , number : &quot;5200828282828210&quot; , year : 2099 , month : 12 , verification_code : &quot;123&quot; , brand : &quot;VISA&quot; } iex&gt; address = % Address { street1 : &quot;301, Gryffindor&quot; , street2 : &quot;Hogwarts School of Witchcraft and Wizardry, Hogwarts Castle&quot; , city : &quot;Highlands&quot; , region : &quot;SL&quot; , country : &quot;GB&quot; , postal_code : &quot;11111&quot; , phone : &quot;(555)555-5555&quot; } iex&gt; options = [ email : &quot;masterofdeath@ministryofmagic.gov&quot; , ip_address : &quot;127.0.0.1&quot; , billing_address : address , description : &quot;For our valued customer, Mr. Potter&quot; ] iex&gt; Gringotts . store ( Gringotts.Gateways.Trexle , card , options )","ref":"Gringotts.Gateways.Trexle.html#store/2","title":"Gringotts.Gateways.Trexle.store/2","type":"function"},{"doc":"Catches gateway configuration errors. Raises a run-time ArgumentError if any of the required_config values is not available or missing from the Application config.","ref":"Gringotts.Gateways.Trexle.html#validate_config/1","title":"Gringotts.Gateways.Trexle.validate_config/1","type":"function"}]